Subject: Re: Git for Windows for Unix?

From: Ævar Arnfjörð Bjarmason <[email-masked]>
Date: Thu, 27 Sep 2018 18:22:33 +0200

On Thu, Sep 27 2018, Jonathan Nieder wrote:

> Ævar Arnfjörð Bjarmason wrote:
>
>> GFW is a "friendly fork", but a permanent one it seems. The diff between
>> it and 2.19.0 proper is ~10k lines, and e.g. this last release had
>> experimental stash/rebase in C that 2.19.0 didn't.
>>
>> So it would be great if this were packaged up by linux distro as some
>> "alterate" package of git. I'm putting Jonathan in the "To" line because
>> I'm mainly interested in this for Debian, but maybe there's wider
>> interest at git-packagers...
>
> Please coordinate with Dscho to get these patches into "next" upstream.

I understand that this happens at some trickle, but how up-to-date that
is goes back & forth, here's the history of differences for all major
releases since 2.0.0 to 2.19.0:

    $ for rel in {0..19} ; do echo 2.$rel.0 vanilla v.s. gfw: && git diff --stat v2.$rel.0..$(git tag -l | grep v2.$rel.0.windows) -- '*.[ch]' '*.txt' '*.sh' |grep 'files changed'; done
    2.0.0 vanilla v.s. gfw:
     1790 files changed, 242271 insertions(+), 76973 deletions(-)
    2.1.0 vanilla v.s. gfw:
     1757 files changed, 231844 insertions(+), 75560 deletions(-)
    2.2.0 vanilla v.s. gfw:
     1733 files changed, 222517 insertions(+), 74745 deletions(-)
    2.3.0 vanilla v.s. gfw:
     66 files changed, 1612 insertions(+), 234 deletions(-)
    2.4.0 vanilla v.s. gfw:
     83 files changed, 2483 insertions(+), 299 deletions(-)
    2.5.0 vanilla v.s. gfw:
     89 files changed, 3150 insertions(+), 512 deletions(-)
    2.6.0 vanilla v.s. gfw:
     94 files changed, 3327 insertions(+), 538 deletions(-)
    2.7.0 vanilla v.s. gfw:
     95 files changed, 3616 insertions(+), 590 deletions(-)
    2.8.0 vanilla v.s. gfw:
     60 files changed, 3091 insertions(+), 497 deletions(-)
    2.9.0 vanilla v.s. gfw:
     60 files changed, 2945 insertions(+), 482 deletions(-)
    2.10.0 vanilla v.s. gfw:
     79 files changed, 6053 insertions(+), 1271 deletions(-)
    2.11.0 vanilla v.s. gfw:
     113 files changed, 6337 insertions(+), 1051 deletions(-)
    2.12.0 vanilla v.s. gfw:
     110 files changed, 4509 insertions(+), 868 deletions(-)
    2.13.0 vanilla v.s. gfw:
     122 files changed, 4217 insertions(+), 919 deletions(-)
    2.14.0 vanilla v.s. gfw:
     151 files changed, 5237 insertions(+), 1093 deletions(-)
    2.15.0 vanilla v.s. gfw:
     178 files changed, 4903 insertions(+), 912 deletions(-)
    2.16.0 vanilla v.s. gfw:
     172 files changed, 4614 insertions(+), 940 deletions(-)
    2.17.0 vanilla v.s. gfw:
     163 files changed, 4574 insertions(+), 882 deletions(-)
    2.18.0 vanilla v.s. gfw:
     163 files changed, 4688 insertions(+), 883 deletions(-)
    2.19.0 vanilla v.s. gfw:
     184 files changed, 9197 insertions(+), 1271 deletions(-)

So it's similar to various packages that have "alternates" and are semi
or permanently forked, like emacs & xemacs, JDK etc., although I can't
recall one offhand that's quite similar to GFW v.s. git.git.

My only stake in this is I thought it would be neat to be able to "apt
install git-for-windows", but I understand there's a support burden, but
if some *nix packagers are interested, maybe never taking it out of the
Debian equivalent of "experimental" and saying "this is unsupported, go
to the GFW tracker..." when bugs are filed would cut down on the support
burden.